#ifndef GRAVSOFTGRID_H
#define GRAVSOFTGRID_H

#include <QVector>
#include <QString>

class GravsoftGrid
{
public:
    GravsoftGrid();

    bool open(QString fileName);
    int latitudeSize(){return(privLatitudeSize);}
    int longitudeSize(){return(privLongitudeSize);}
    double interpolateValue(double longitude, double latitude);

    double value(int longitudeIndex, int latitudeIndex);
    double latitude(int latitudeIndex);
    double longitude(int longitudeIndex);

    double latitudeMin(){return(privLatitudeMin);}
    double latitudeMax(){return(privLatitudeMax);}
    double latitudeSpacing(){return(privLatitudeDelta/(privLatitudeSize-1.0));}

    double longitudeMin(){return(privLongitudeMin);}
    double longitudeMax(){return(privLongitudeMax);}
    double longitudeSpacing(){return(privLongitudeDelta/(privLongitudeSize-1.0));}

    bool setValue(int longitudeIndex, int latitudeIndex, double value);


private:
    double privLatitudeMin, privLatitudeMax, privLatitudeDelta;
    double privLongitudeMin, privLongitudeMax, privLongitudeDelta;
    int privLatitudeSize, privLongitudeSize;
    QVector<double> privData;
};

#endif // GRAVSOFTGRID_H
